//+------------------------------------------------------------------+
//|                                                   TickATR_v1.mq4 |
//|                                Copyright  2009, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    Tomato
#property indicator_width1    1
#property indicator_color2    Aqua
#property indicator_minimum   0
//---- buffers
extern int     ATRLength   =    14; //ATR Length(Period)
extern int     NumTicks    =     0; //TimeFrame in ticks (=0 if NumSecs  > 0)
extern int     NumSecs     =    10; //TimeFrame in secs  (=0 if NumTicks > 0) 
extern int     MaxBars     =    50; //Max Number of ticks   

double tATR[];
double TR[];
double Hi[];
double Lo[];
double tClose[];


int      tickCounter=0, barCounter, pSecs;
datetime pTime;
string   short_name, t;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, tATR);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, TR);
   SetIndexBuffer(2, Hi);
   SetIndexBuffer(3, Lo);
   SetIndexBuffer(4, tClose);
         
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   if(NumTicks > 0) t = NumTicks +" Ticks] ";
   if(NumSecs  > 0) t = NumSecs  +" Secs] ";
   short_name="TickATR_v1 ["+t+"("+ATRLength+","+MaxBars+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Tick ATR");
   SetIndexLabel(1,"True Range");
      
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   
   pTime = Time[0];
   pSecs = TimeCurrent();       
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
//----
   return(0);
}

void ShiftArray(int mode)
{
   if(mode==0)
   {
      for(int cnt=barCounter; cnt >= 0; cnt--)
      {
      tATR [cnt] = tATR[cnt-1];
      Hi [cnt] = Hi[cnt-1];
      Lo [cnt] = Lo[cnt-1];
      tClose[cnt] = tClose[cnt-1];
      TR [cnt] = TR[cnt-1];
      }
   }
   else
   {
      for(cnt=1; cnt <= barCounter; cnt++)
      {
      tATR [cnt-1] = tATR[cnt];
      Hi [cnt-1] = Hi[cnt];
      Lo [cnt-1] = Lo[cnt];
      tClose[cnt-1] = tClose[cnt];
      TR [cnt-1] = TR[cnt];
      
      tATR[cnt]=0.0;    
      Hi[cnt]=0.0;
      Lo[cnt]=0.0;
      tClose[cnt]=0.0;
      TR[cnt]=0.0;
      }
   }
}

bool isNewBar()
{
   bool res=false;
   if (Time[0]!=pTime)
   {
   res=true;
   pTime=Time[0];
   }   

   return(res);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
   
   if(cnt_bars < 1) 
   {
      for(i=Bars-1;i>=0;i--)
      {
      tATR[i] = 0.0;
      TR[i]   = 0.0;
      }
   }
   
   tickCounter++;
   
   bool tcond = false;   
   if(NumTicks > 0 && NumSecs == 0) tcond = tickCounter > 0 && tickCounter % NumTicks == 0;
   if(NumTicks == 0 && NumSecs > 0) tcond = TimeCurrent() >= pSecs + NumSecs;
   
   if(tcond) 
   {
   barCounter ++; 
   if(!isNewBar()) ShiftArray(0);
   tClose[0]=Bid;
   Hi[0]=Bid;
   Lo[0]=Bid; 
   if(NumSecs > 0) pSecs = TimeCurrent();
   }
   
   if(barCounter > 1)
   {
   if(isNewBar()) ShiftArray(1);
   tClose[0]=Bid;
   Hi[0]=MathMax(Hi[0],Bid);
   if(Lo[0] > 0) Lo[0]=MathMin(Lo[0],Bid); else Lo[0]=Bid;
   
   if(NumTicks == 1) TR[0] = MathAbs(tClose[0] - tClose[1]);
   else
   TR[0] = MathMax(Hi[0],tClose[1]) - MathMin(Lo[0],tClose[1]);
   }
   
   if(barCounter >= MaxBars) 
   {
      for(i=MaxBars; i<MaxBars+10;i++)
      { 
      tATR[i] = 0.0;
      TR[i]=0.0;
      }
   }
      
   if(barCounter > ATRLength) tATR[0] = TickSMA(TR, ATRLength);          
        
//----
   return(0);
}
//+------------------------------------------------------------------+
double TickSMA(double& array[],int per)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) Sum += array[i];
   return(Sum/per);
}                


